Subject: Re: Git / Subversion Interoperability

From: "Shawn O. Pearce" <[email-masked]>
Date: Thu, 22 Mar 2007 21:24:23 -0400

Julian Phillips <[email-masked]> wrote:
> On Thu, 22 Mar 2007, Shawn O. Pearce wrote:
> >Bruno Cesar Ribas <[email-masked]> wrote:
> >>2.  write a backend for Subversion
> >
> >In this case we try to reuse the existing SVN server code by
> >creating a library module that plugs into that system
...
> >downside is you have to write code to run within their library and
> >address space, and that conforms to their storage API.
> 
> This might run headlong into some of the issues facing the libification 
> project - in particular the tendancy of git code to die as a primary error 
> handling mechanism.  This approach may not viable without access to a 
> libified git?

Yes, exactly.  The libification won't be ready early enough for
this project.  So that does make it more difficult.  But this just
points out another reason why libification might be useful. ;-)

> >- Branches.  In SVN these are in the repository wide namespace,
> >but in Git they aren't.  I imagine we'd want to just enforce the
> >standard layout that the SVN people recommened:
...
> That would probably be good enough for the majority of 
> one-project-per-repo Subversion projects at least.  Though there is still 
> the issue that Subversion will actually let you create a "tag" simply by 
> committing whatever you currently have in your working copy (including 
> localally modified files ... yeuch).

Heh.  People do weird things.  ;-)
 
> >That's all I can think of right now.  But I'm sure there are more.
> 
> Properties are probably the next biggest headache.  Subversion allows you 
> to associate arbitrary keyword value pairs with files (which are 
> versioned) and with revisions (which are not versioned).  You would need 
> to find someway to support this in git.  Since revision properties are 
> disabled by default in Subversion you may be able to simply disallow them 
> permanently - but I don't know anything about the Subversion protocol ...

I thought about the properties, but didn't bother to write anything
on that subject as we may just be able to say "look, properties
are not supported in git-svnserver, so don't try to use them".

The git-svnserver is meant to help users migrate to Git, not to offer
up all of SVNs features and warts.  A big part of this project may
just be deciding what features we are willing to try to emulate.

-- 
Shawn.